require "Cocos2d"
require("src/MatchGlobal")
require("src/LuaClass")


GameLayer = class(cc.Layer)

--GameLayer.__index = GameLayer
GameLayer.allCards = {}

function GameLayer:createLayer()
    local layer = GameLayer.new()
    layer:initLayer()
    return layer
end


function GameLayer:initLayer()
    -- add in farm background
    local bg = cc.Sprite:create("MatchBg.png")
    bg:setPosition(visibleSize.width / 2, visibleSize.height / 2)
    self:addChild(bg)

    local cache = cc.SpriteFrameCache:getInstance()
    cache:addSpriteFrames("Match.plist", "Match.png")

    self:initAllCards()
    self:initAllCardsLayout()

    MatchLayer = self
end

local function compare(v1, v2)
    return v1.random > v2.random
end

function GameLayer:initAllCards()


    local card2 = MatchCard:createWithSpriteFrameName("MatchCard2.png",2);
    local card2_1 = MatchCard:createWithSpriteFrameName("MatchCard2_1.png",2);
    local card3 = MatchCard:createWithSpriteFrameName("MatchCard3.png",3);
    local card3_1 = MatchCard:createWithSpriteFrameName("MatchCard3_1.png",3);
    local card4 = MatchCard:createWithSpriteFrameName("MatchCard4.png",4);
    local card4_1 = MatchCard:createWithSpriteFrameName("MatchCard4_1.png",4);
    local card5 = MatchCard:createWithSpriteFrameName("MatchCard5.png",5);
    local card5_1 = MatchCard:createWithSpriteFrameName("MatchCard5_1.png",5);
    local card6 = MatchCard:createWithSpriteFrameName("MatchCard6.png",6);
    local card6_1 = MatchCard:createWithSpriteFrameName("MatchCard6_1.png",6);
    local card7 = MatchCard:createWithSpriteFrameName("MatchCard7.png",7);
    local card7_1 = MatchCard:createWithSpriteFrameName("MatchCard7_1.png",7);
    local card8 = MatchCard:createWithSpriteFrameName("MatchCard8.png",8);
    local card8_1 = MatchCard:createWithSpriteFrameName("MatchCard8_1.png",8);
    local card9 = MatchCard:createWithSpriteFrameName("MatchCard9.png",9);
    local card9_1 = MatchCard:createWithSpriteFrameName("MatchCard9_1.png",9);

    self:addChild(card2)
    self:addChild(card2_1)
    self:addChild(card3)
    self:addChild(card3_1)
    self:addChild(card4)
    self:addChild(card4_1)
    self:addChild(card5)
    self:addChild(card5_1)
    self:addChild(card6)
    self:addChild(card6_1)
    self:addChild(card7)
    self:addChild(card7_1)
    self:addChild(card8)
    self:addChild(card8_1)
    self:addChild(card9)
    self:addChild(card9_1)

    table.insert(self.allCards,card2)
    table.insert(self.allCards,card2_1)
    table.insert(self.allCards,card3)
    table.insert(self.allCards,card3_1)
    table.insert(self.allCards,card4)
    table.insert(self.allCards,card4_1)
    table.insert(self.allCards,card5)
    table.insert(self.allCards,card5_1)
    table.insert(self.allCards,card6)
    table.insert(self.allCards,card6_1)
    table.insert(self.allCards,card7)
    table.insert(self.allCards,card7_1)
    table.insert(self.allCards,card8)
    table.insert(self.allCards,card8_1)
    table.insert(self.allCards,card9)
    table.insert(self.allCards,card9_1)

    table.sort(self.allCards,compare)
end


function GameLayer:initAllCardsLayout()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local xIndex = 0
    local yIndex = 0
    for i = 1,#(self.allCards) do
        --cclog("t")
        self.allCards[i]:setPosition(visibleSize.width / 2, visibleSize.height / 2)
        local moveAction = cc.MoveTo:create(0.7, cc.p(MatchCardStartPositionX + xIndex * MatchCardMargin,
            MatchCardStartPositionY - yIndex * MatchCardMargin))
        self.allCards[i]:runAction(moveAction)
        xIndex = xIndex + 1
        if(xIndex == 4) then
            xIndex = 0
            yIndex = yIndex + 1
        end
    end
end