require ("src/MatchGlobal")


local MatchCardAnimationTime = 0.3
math.randomseed(tostring(os.time()):reverse():sub(1, 6))

MatchCard = class("Match",function (spriteFrameName, value)
    MatchCard.mainFrame = spriteFrameName
    MatchCard.value = value
    MatchCard.random = math.random()--普通洗牌用
    MatchCard.random1 = math.random()--AI选牌用
    return cc.Sprite:createWithSpriteFrameName("MatchCardBg.png")
end)

MatchCard.__index = MatchCard

MatchCard.alreadyTouch = false



function MatchCard:createWithSpriteFrameName(spriteFrameName, value)
    local card = MatchCard.new(spriteFrameName, value)
    card:registerScriptHandler(function(tag)
    if "enter" == tag then
        card:onEnter()
    elseif "exit" == tag then
    end
    end)
	return card
end

--function MatchCard:getRect()
--   local s = self:getTexture():getContentSize()
--   return cc.rect(-s.width / 2, -s.height / 2, s.width, s.height);
--end



function MatchCard:containsTouchLocation(x,y)
	local position = cc.p(self:getPosition())
	local s = self:getContentSize()
    local touchRect = cc.rect(-s.width / 2 + position.x, -s.height / 2 + position.y, s.width, s.height)
    local b = cc.rectContainsPoint(touchRect,cc.p(x,y))
    return b
end

function MatchCard:getValue()
   return self.value
end

function MatchCard:changeFrameToMainFrame()
    self:setSpriteFrame(self.mainFrame)
end

function MatchCard:changeFrameToBgFrame()
    local bgFrame = cc.SpriteFrameCache:getInstance():getSpriteFrameByName("MatchCardBg.png");
    self:setSpriteFrame(bgFrame);
end

function MatchCard:setCanTouch()
    self.alreadyTouch = false;
end


function MatchCard:runFlipAction()
    print("runFlipAction")
    local changeFrame = cc.Sequence:create(cc.DelayTime:create(MatchCardAnimationTime / 2),
        cc.CallFunc:create(self.changeFrameToMainFrame));
    local rotateAction = cc.OrbitCamera:create(MatchCardAnimationTime,1, 0, 0, 180, 0, 0)
    local apawnAction = cc.Spawn:create(changeFrame,rotateAction);

    self:runAction(apawnAction);
end

function MatchCard:runFlipBackAction()
     local changeFrame = cc.Sequence:create(cc.DelayTime:create(MatchCardAnimationTime / 2),
        cc.CallFunc:create(self.changeFrameToBgFrame))
    local rotateAction = cc.OrbitCamera:create(MatchCardAnimationTime,1, 0, 0, 180, 0, 0)
    local apawnAction = cc.Spawn:create(changeFrame,rotateAction)
    local seq = cc.Sequence:create(apawnAction,cc.CallFunc:create(self.setCanTouch))
    self:runAction(seq);
end

function MatchCard:onEnter()
    --print("onEnter")
    local  listenner = cc.EventListenerTouchOneByOne:create()
    listenner:setSwallowTouches(true)
    listenner:registerScriptHandler(function(touch, event)
        --print(string.format("MatchCard::onTouchBegan id = %d, x = %f, y = %f", touch:getId(), touch:getLocation().x, touch:getLocation().y))
        
        if not self:containsTouchLocation(touch:getLocation().x,touch:getLocation().y) then
            return false
        end
        
        if (PlayerClickCardNum ~= 2 and self.alreadyTouch == false) then 
            self:runFlipAction()
            self.alreadyTouch = true
            PlayerClickCardNum = PlayerClickCardNum + 1
            if (PlayerClickCardNum == 1) then
               PlayerFirstCards = self
            else   
               PlayerSecondCards = self
            end
        end

        return true
    end,cc.Handler.EVENT_TOUCH_BEGAN )
    
    listenner:registerScriptHandler(function(touch, event)   
    end,cc.Handler.EVENT_TOUCH_MOVED )
    
    listenner:registerScriptHandler(function(touch, event)    
    end,cc.Handler.EVENT_TOUCH_ENDED )
    
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listenner, self)
end