require("src/MatchState")
require("src/MatchGlobal")

MatchCheckAICardsState = class(MatchState)

function MatchCheckAICardsState:ctor()
end


function MatchCheckAICardsState:Execute()
    if(self.isLock == true) then
        return
    end
    self.isLock = true

    if(AIFirstCard:getValue() == AISecondCard:getValue()) then
        --remove from container
        MatchCardMemory:removeTwoCardsFromMemory(AIFirstCard,AISecondCard)

        local seq = cc.Sequence:create(
            cc.CallFunc:create(self.removeAICard),
            cc.DelayTime:create(0.5),
            cc.CallFunc:create(self.waitAIPlay))
        MatchLayer:runAction(seq);
        AIScore = AIScore + 2
    else
        --log("have the different value!!");
        self:changeTwoAICardsToBack()
    end
end

function MatchCheckAICardsState:removeAICard()
    AIFirstCard:setLocalZOrder(2)
    local moveAction = cc.MoveTo:create(MatchCardMoveOutTime,cc.p(-MatchCardMoveMarginLeft,500))
    local rotateAction = cc.RotateTo:create(MatchCardMoveOutTime,-20)
    local spawnAction = cc.Spawn:create(moveAction,rotateAction)
    AIFirstCard:runAction(spawnAction)

    local spawnAction1 = spawnAction:clone()
    AISecondCard:setLocalZOrder(2)
    AISecondCard:runAction(spawnAction1)

    MatchCardMemory:removeTwoCardsFromAllCards(AIFirstCard, AISecondCard)
end

function MatchCheckAICardsState:waitAIPlay()
   changeState(MatchAIThinkState.new())
end

function MatchCheckAICardsState: waitPlayerPlay()
   changeState(MatchWaitingPlayerState.new());
end

function MatchCheckAICardsState:changeTwoAICardsToBack()
   AIFirstCard:runFlipBackAction()
   AISecondCard:runFlipBackAction()
    --等待片刻,变成Player回合
    local seq = cc.Sequence:create(cc.DelayTime:create(0.5),
        cc.CallFunc:create(self.waitPlayerPlay))
    MatchLayer:runAction(seq);
end