require "Cocos2d"
require "Cocos2dConstants"
require "src/MatchCard"
require "src/MatchWaitingPlayerState"
require("src/MatchCardMemory")
--require "src/LuaClass"

-- cclog
cclog = function(...)
    print(string.format(...))
end

-- for CCLuaEngine traceback
function __G__TRACKBACK__(msg)
    cclog("----------------------------------------")
    cclog("LUA ERROR: " .. tostring(msg) .. "\n")
    cclog(debug.traceback())
    cclog("----------------------------------------")
    return msg
end

local function main()
    collectgarbage("collect")
    -- avoid memory leak
    collectgarbage("setpause", 100)
    collectgarbage("setstepmul", 5000)
    cc.Director:getInstance():getOpenGLView():setDesignResolutionSize(640, 960, 0)
	cc.FileUtils:getInstance():addSearchResolutionsOrder("src");
	cc.FileUtils:getInstance():addSearchResolutionsOrder("res");
	local schedulerID = 0
    --support debug
    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if (cc.PLATFORM_OS_IPHONE == targetPlatform) or (cc.PLATFORM_OS_IPAD == targetPlatform) or 
       (cc.PLATFORM_OS_ANDROID == targetPlatform) or (cc.PLATFORM_OS_WINDOWS == targetPlatform) or
       (cc.PLATFORM_OS_MAC == targetPlatform) then
        --cclog("result is ")
		--require('debugger')()
        
    end

    ---------------

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local origin = cc.Director:getInstance():getVisibleOrigin()

    local allCards = {}
    local MatchCardStartPositionX = 146
    local MatchCardMargin = 114
    local MatchCardStartPositionY = 520
    currentState = MatchWaitingPlayerState.new()
    
    local function compare(v1, v2)
       return v1.random > v2.random
    end

    local function initAllCards(layer)
        

        local card2 = MatchCard:createWithSpriteFrameName("MatchCard2.png",2);
        local card2_1 = MatchCard:createWithSpriteFrameName("MatchCard2_1.png",2);
        local card3 = MatchCard:createWithSpriteFrameName("MatchCard3.png",3);
        local card3_1 = MatchCard:createWithSpriteFrameName("MatchCard3_1.png",3);
        local card4 = MatchCard:createWithSpriteFrameName("MatchCard4.png",4);
        local card4_1 = MatchCard:createWithSpriteFrameName("MatchCard4_1.png",4);
        local card5 = MatchCard:createWithSpriteFrameName("MatchCard5.png",5);
        local card5_1 = MatchCard:createWithSpriteFrameName("MatchCard5_1.png",5);
        local card6 = MatchCard:createWithSpriteFrameName("MatchCard6.png",6);
        local card6_1 = MatchCard:createWithSpriteFrameName("MatchCard6_1.png",6);
        local card7 = MatchCard:createWithSpriteFrameName("MatchCard7.png",7);
        local card7_1 = MatchCard:createWithSpriteFrameName("MatchCard7_1.png",7);
        local card8 = MatchCard:createWithSpriteFrameName("MatchCard8.png",8);
        local card8_1 = MatchCard:createWithSpriteFrameName("MatchCard8_1.png",8);
        local card9 = MatchCard:createWithSpriteFrameName("MatchCard9.png",9);
        local card9_1 = MatchCard:createWithSpriteFrameName("MatchCard9_1.png",9);

        layer:addChild(card2)
        layer:addChild(card2_1)
        layer:addChild(card3)
        layer:addChild(card3_1)
        layer:addChild(card4)
        layer:addChild(card4_1)
        layer:addChild(card5)
        layer:addChild(card5_1)
        layer:addChild(card6)
        layer:addChild(card6_1)
        layer:addChild(card7)
        layer:addChild(card7_1)
        layer:addChild(card8)
        layer:addChild(card8_1)
        layer:addChild(card9)
        layer:addChild(card9_1)
        
        table.insert(MatchCardMemory.allCards,card2)
        table.insert(MatchCardMemory.allCards,card2_1)
        table.insert(MatchCardMemory.allCards,card3)
        table.insert(MatchCardMemory.allCards,card3_1)
        table.insert(MatchCardMemory.allCards,card4)
        table.insert(MatchCardMemory.allCards,card4_1)
        table.insert(MatchCardMemory.allCards,card5)
        table.insert(MatchCardMemory.allCards,card5_1)
        table.insert(MatchCardMemory.allCards,card6)
        table.insert(MatchCardMemory.allCards,card6_1)
        table.insert(MatchCardMemory.allCards,card7)
        table.insert(MatchCardMemory.allCards,card7_1)
        table.insert(MatchCardMemory.allCards,card8)
        table.insert(MatchCardMemory.allCards,card8_1)
        table.insert(MatchCardMemory.allCards,card9)
        table.insert(MatchCardMemory.allCards,card9_1)
        
        table.sort(MatchCardMemory.allCards,compare)
    end

    local function initAllCardsLayout()
        local xIndex = 0
        local yIndex = 0
        for i = 1,#(MatchCardMemory.allCards) do
            --cclog("t")
            MatchCardMemory.allCards[i]:setTag(xIndex + yIndex * 4)
            MatchCardMemory.allCards[i]:setPosition(visibleSize.width / 2, visibleSize.height / 2)
            local moveAction = cc.MoveTo:create(0.7, cc.p(MatchCardStartPositionX + xIndex * MatchCardMargin,
                MatchCardStartPositionY - yIndex * MatchCardMargin))
            MatchCardMemory.allCards[i]:runAction(moveAction)
            xIndex = xIndex + 1
            if(xIndex == 4) then
              xIndex = 0
              yIndex = yIndex + 1
            end
        end
    end
 

    local function createMatchLayer()
        local layerFarm = cc.Layer:create()

        local bg = cc.Sprite:create("MatchBg.png")
        bg:setPosition(visibleSize.width / 2, visibleSize.height / 2)
        layerFarm:addChild(bg)
        
        local cache = cc.SpriteFrameCache:getInstance()
        cache:addSpriteFrames("Match.plist", "Match.png")
        
        initAllCards(layerFarm)
        initAllCardsLayout()
        
        MatchLayer = layerFarm
        return layerFarm
    end
    
    local function restartGame()
        MatchLayer:removeAllChildren(true)
        local bg = cc.Sprite:create("MatchBg.png")
        bg:setPosition(visibleSize.width / 2, visibleSize.height / 2)
        MatchLayer:addChild(bg)
        initAllCards(MatchLayer)
        initAllCardsLayout()
        currentState = MatchWaitingPlayerState.new()
    end
    
    local function checkGameOver()
        if(#(MatchCardMemory.allCards) == 0) then
          print("Game Over")
          if(PlayerScore < AIScore)then
             print("You lose!")
          elseif(PlayerScore == AIScore)then
             print("Equal!")
          else 
             print("You Win!")
          end
          restartGame()
        end
    end
    

    local function update(dt)
        checkGameOver()
        currentState:Execute(dt);
    end

    cc.Director:getInstance():getScheduler():scheduleScriptFunc(update, 0, false)
    
    --initAllCardsLayout()
   
    -- run
    local sceneGame = cc.Scene:create()
    sceneGame:addChild(createMatchLayer())
	
	if cc.Director:getInstance():getRunningScene() then
		cc.Director:getInstance():replaceScene(sceneGame)
	else
		cc.Director:getInstance():runWithScene(sceneGame)
	end


    
end


local status, msg = xpcall(main, __G__TRACKBACK__)
if not status then
    error(msg)
end
